using System;
using System.Collections.Generic;
using System.Text;

namespace InfoQ.AspectsOfDMM.Version1
{
    /// <summary>
    /// The Person class should support dirty tracking
    /// </summary>
    public class Person : IDirty
    {
        protected string name;
        public virtual string Name
        {
            get { return name; }
            set
            {
                if (value != name)
                    ((IDirty)this).Dirty = true;
                name = value;
            }
        }

        private bool dirty;
        bool IDirty.Dirty
        {
            get { return dirty; }
            set 
            { 
                if (value)
                    Console.WriteLine("[Interceptor marking object as dirty]");

                dirty = value; 
            }
        }
    }
}
