using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace InfoQ.AspectsOfDMM.Version3
{
    public class LazyInterceptor
    {
        public void OnPropertyGetSet(object obj, string propertyName)
        {
            ILazy lazy = obj as ILazy;
            if (lazy != null)
            {
                if (!lazy.Loaded)
                {
                    lazy.Loaded = true;

                    //simulate lazy loading...
                    if (propertyName == "Name")
                        WriteToField(obj, propertyName, "John");
                    else if (propertyName == "Salary")
                        WriteToField(obj, propertyName, 1000);
                }
            }
        }

        private static void WriteToField(object obj, string propertyName, object value)
        {
            obj.GetType().BaseType.BaseType.GetField(
                propertyName.ToLower(),
                BindingFlags.Instance |
                BindingFlags.Public |
                BindingFlags.NonPublic |
                BindingFlags.DeclaredOnly).SetValue(obj, value);
        }
    }
}
