using System;
using System.Collections.Generic;
using System.Text;

namespace InfoQ.AspectsOfDMM.Version3
{
    /// <summary>
    /// This reusable mixin makes the lazy loading
    /// logic reusable between targets.
    /// </summary>
    public class LazyMixin : ILazy
    {
        private bool loaded;
        /// <summary>
        /// The Loaded property is "write-once" -
        /// after you have set it to true you can not set 
        /// it to false again
        /// </summary>
        bool ILazy.Loaded
        {
            get { return loaded; }
            set
            {
                if (loaded)
                    return;

                Console.WriteLine("[Interceptor lazy loading object]");

                loaded = value;
            }
        }
    }
}
