using System;
using System.Collections.Generic;
using System.Text;
using Puzzle.NAspect.Framework.Interception;
using Puzzle.NAspect.Framework;

namespace InfoQ.AspectsOfDMM.Aspects
{
    public class DirtyInterceptor : IAroundInterceptor
    {
        public object HandleCall(MethodInvocation call)
        {
            IDirty dirty = call.Target as IDirty;

            if (dirty != null)
            {
                //Extract the new value from the call object
                object newValue = call.Parameters[0].Value;

                //Extract the current value using reflection
                object value = call.Target.GetType().GetProperty(
                    call.Method.Name.Substring(4)).GetValue(
                    call.Target, null);

                //Mark as dirty if the new value is 
                //different from the old value
                if (!value.Equals(newValue))
                    dirty.Dirty = true;
            }

            return call.Proceed();
        }
    }
}
