using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using Puzzle.NAspect.Framework;
using Puzzle.NAspect.Framework.Interception;

namespace InfoQ.AspectsOfDMM.Aspects
{
    public class LazyInterceptor : IAroundInterceptor
    {
        public object HandleCall(MethodInvocation call)
        {
            ILazy lazy = call.Target as ILazy;

            if (lazy != null)
            {
                if (!lazy.Loaded)
                {
                    lazy.Loaded = true;

                    //parse out the property name by dumping
                    //the get_ or set_ prefix from the method name
                    string propertyName = 
                        call.Method.Name.Substring(4);

                    //simulate lazy loading...
                    if (propertyName == "Name")
                        WriteToField(call.Target, propertyName, "John");
                    else if (propertyName == "Salary")
                        WriteToField(call.Target, propertyName, 1000);
                }
            }

            return call.Proceed();
        }

        private static void WriteToField(object obj, string propertyName, object value)
        {
            obj.GetType().BaseType.BaseType.GetField(
                propertyName.ToLower(),
                BindingFlags.Instance |
                BindingFlags.Public |
                BindingFlags.NonPublic |
                BindingFlags.DeclaredOnly).SetValue(obj, value);
        }
    }
}
